/* $Id$

   Open - record and display opening times
   Copyright (C) 2003 Fraser McCrossan http://www.joat.ca

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA
*/

/* set error levels */
#define ERROR_CHECK_LEVEL ERROR_CHECK_FULL
#define UNUSED  __attribute__((__unused__))

/* my creator ID */
#define appID 'OnHr'
#define oldappID 'Temp'
#define version 0x0002
#define v1 0x0001
#define DBName "OpenDB"
#define DBType 'Data'

#define CardNum 0

typedef struct {
  UInt16 category;
  Int16 firstidx; /* first index of database being displayed */
  UInt16 sortdir; /* sort direction of database */
  Boolean hour24; /* 24-hour mode, the default */
} preftype;

#define DAYSINWEEK 7
#define MINUTESINDAY (24 * 60)
#define MINUTESINHOUR 60
#define NEVERCHANGE ((DAYSINWEEK+1)*MINUTESINDAY) /* since this can never happen */

typedef Int16 opentimetype;
typedef struct {
  opentimetype openat[DAYSINWEEK];
  opentimetype closeat[DAYSINWEEK];
  opentimetype exceptfrom[DAYSINWEEK];
  opentimetype exceptto[DAYSINWEEK];
  UInt8 pastmid; /* one bit for each day denotes whether to reverse
                    the times to indicate a closing time past midnight
                    - this works around the problem in the system time
                    selector dialog */
} openclose; /* each item must have times for every day of the week -
		each record also has a name, but it's spliced into the
		record at run-time, to keep the size down */

/* this is the old definition; we use this when upgrading from an old
   version */
typedef struct {
  opentimetype openat[DAYSINWEEK];
  opentimetype closeat[DAYSINWEEK];
  UInt8 pastmid; /* one bit for each day denotes whether to reverse
                    the times to indicate a closing time past midnight
                    - this works around the problem in the system time
                    selector dialog */
} openclosev1; /* each item must have times for every day of the week -
		  each record also has a name, but it's spliced into the
		  record at run-time, to keep the size down */

extern DmOpenRef db;
extern LocalID dbid;

extern UInt32 rom_version;
extern Boolean on_poser;

extern preftype prefs; /* every source file gets to see this */

/* function prototypes */

/* mainform */
Boolean MainFormHandler(EventType *);
void * GetObjectPtr(FormType *, UInt16);

/* about form */
Boolean AboutFormHandler(EventType *);

/* place form */
Boolean PlaceFormHandler(EventType *);
void SetNewRecord();
void SetRecord(UInt16);

/* database routines */
DmOpenRef OpenDB(LocalID *rdbid);
void CloseDB(DmOpenRef *);
Err UpdateRecord(DmOpenRef *, UInt16, openclose *, Char *, UInt16);
Err InsertRecord(DmOpenRef *, openclose *, Char *, UInt16);
Err FindIndexFromRow(DmOpenRef *, Int16, UInt16 *);
MemHandle QueryRecord(DmOpenRef *, UInt16, openclose *, Char *);
void SortRecords(DmOpenRef *);
void CheckIfOpen(openclose *, Boolean *, opentimetype *);
